import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useState as o, useLayoutEffect as r, useMemo as n, useEffect as i, useRef as s } from "react";

import { Event as l, _ALL_EVENTS as c, VirtualScroller as a } from "@af-utils/virtual-core";

import { useSyncExternalStore as h } from "use-sync-external-store/shim";

/**
 * @public
 * Map current visible items
 */ const f = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to; n > r; r++) o.push(e(r));
    return o;
}, d = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to, i = t.getOffset(r); n > r; r++, i += t.getSize(r)) o.push(e(r, i));
    return o;
}, u = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    // otherwise may go above sticky header
    zIndex: -1
}, m = {
    ...u,
    height: "100%"
}, p = {
    ...u,
    width: "100%"
}, S = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, v = {
    ...S,
    display: "flex",
    height: "100%"
}, g = {
    ...S,
    display: "block",
    width: "100%"
}, y = t => {
    const [e, n] = o(null), [i, s] = o(null);
    return r((() => {
        if (e && i) {
            const o = t.on((() => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }), [ l.SCROLL_SIZE ]), r = t.on((() => {
                const e = t.getOffset(t.from), o = t.getOffset(t.to);
                i.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, i.style[t.horizontal ? "width" : "height"] = o - e + "px";
            }), [ l.RANGE, l.SIZES ]);
            return Object.assign(e.style, t.horizontal ? m : p), Object.assign(i.style, t.horizontal ? v : g), 
            () => {
                o(), r();
            };
        }
    }), [ t, e, i ]), [ n, s ];
};

/**
 * @public
 * Map current visible items and provide offset for each item.
 * Used in scenarios, when each item is absolutely positioned
 */ function x(t) {
    switch (t) {
      case l.RANGE:
        return this.to ** 2 + this.from;

        // szudzik pair
              case l.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

/**
 * @public
 * React hook.
 * Rerenders component when one of {@link @af-utils/virtual-core#Event} gets emitted.
 * Usually {@link Subscription} is a better alternative
 */ const z = function(t, e) {
    void 0 === e && (e = c);
    const [o, r] = n((() => [ o => t.on(o, e), () => e.map(x, t).join() ]), [ t, e ]);
    h(o, r, r);
}, w = t => (z(t.model, t.events), t.children()), E = o => {
    let {model: r, children: n, itemData: i, component: s, header: c = null, footer: a = null, getKey: h = (t => t), tabIndex: d = -1, style: u, ...m} = o;
    const p = s || "div", [S, v] = y(r);
    return t(p, {
        ...m,
        style: {
            overflow: "auto",
            contain: "strict",
            ...u
        },
        ref: r.setScroller,
        tabIndex: d,
        children: [ c, e("div", {
            ref: S,
            children: e("div", {
                ref: v,
                children: e(w, {
                    model: r,
                    events: [ l.RANGE ],
                    children: () => f(r, (t => e(n, {
                        model: r,
                        i: t,
                        data: i
                    }, h(t, i))))
                })
            })
        }), a ]
    });
}, I = process.env.__IS_SERVER__ ? i : r, O = (t, e) => I((() => (t.setScroller(e), 
() => t.setScroller(null))), [ t, e ])
/**
 * @public
 * React hook.
 * Allows to subscribe to {@link @af-utils/virtual-core#Event} without unnecessary rerenders.
 * For example can be used in load-on-demand.
 */ , R = (t, e, o) => i((() => {
    if (o) return o(), t.on(o, e);
}), [ t, o, e ])
/**
 * @public
 * React hook.
 * Creates and stores one {@link @af-utils/virtual-core#VirtualScroller} instance.
 * It does not get recreated during component lifecycle.
 * Normally {@link useVirtual} should be used.
 */ , _ = t => s().current ||= new a(t)
/**
 * @public
 * React hook.
 * Calls {@link useVirtualModel} and synchronizes it with props
 */ , b = t => {
    const e = _(t);
    return I((() => e.set(t))), e;
};

/**
 * @public
 * React component
 * Rerenders only on certain {@link @af-utils/virtual-core#Event}
 * Allows to optimize performance
 */ export { E as List, w as Subscription, f as mapVisibleRange, d as mapVisibleRangeWithOffset, z as useComponentSubscription, O as useScroller, R as useSubscription, y as useSyncedStyles, b as useVirtual, _ as useVirtualModel };
//# sourceMappingURL=index.js.map
