import type { VirtualScroller } from "@af-utils/virtual-core";
import type { ReactNode } from "react";
/**
 * @public
 * {@link Subscription} component props
 */
export type SubscriptionProps = {
    /**
     * {@inheritDoc @af-utils/virtual-core#VirtualScroller}
     */
    model: VirtualScroller;
    children: () => ReactNode;
    /**
     * {@inheritDoc @af-utils/virtual-core#Event}
     */
    events?: Parameters<VirtualScroller["on"]>[1];
};
/**
 * @public
 * React component
 * Rerenders only on certain {@link @af-utils/virtual-core#Event}
 * Allows to optimize performance
 */
declare const Subscription: (props: SubscriptionProps) => ReactNode;
export default Subscription;
